<template>
    <el-dialog draggable class="cn-operate-dialog" v-model="dialogVisible" :title="title">
        <el-scrollbar>
            <el-form :inline="false" :model="form" label-width="120px" :rules="rules" ref="formRef">
                <el-form-item label="字典名称:" prop="name">
                    <el-input v-model="form.name" placeholder="请输入字典名称" maxlength="32" clearable show-word-limit @input="handleInput"></el-input>
                </el-form-item>
                <el-form-item label="序号:" prop="sort" class="top">
                    <el-input-number v-model="form.sort" placeholder="请输入序号"></el-input-number>
                </el-form-item>
                <el-form-item label="编码:" prop="code" class="top">
                    <el-input v-model="form.code" placeholder="请输入字典编码" maxlength="32" show-word-limit  clearable ></el-input>
                </el-form-item>
                <el-form-item label="描述:" class="top">
                    <el-input v-model="form.remark" placeholder="请输入字典描述"></el-input>
                </el-form-item>
            </el-form>
        </el-scrollbar>

        <template #footer>
            <span class="dialog-footer">
                <el-button @click="dialogVisible = false">取消</el-button>
                <el-button type="primary" @click="submit">确认</el-button>
            </span>
        </template>
    </el-dialog>
</template>
<script lang="ts" setup>
import { ref, inject } from 'vue'
import { reactive } from 'vue'
import TableStore from '@/utils/tableStore'
import { ElMessage } from 'element-plus'
import { useAdminInfo } from '@/stores/adminInfo'
import { dicAdd, dicUpdate } from '@/api/system-boot/dic'

const formRef = ref()
const adminInfo = useAdminInfo()
const tableStore = inject('tableStore') as TableStore
// do not use same name with ref
const form = reactive({
    name: '',
    code: '',
    remark: '',
    sort: 100,
    type: 0,
    pid: 0,
    id: ''
})
const rules = {
    name: [{ required: true, message: '名称不能为空', trigger: 'blur' }],
    sort: [{ required: true, message: '排序不能为空', trigger: 'blur' }],
    code: [{ required: true, message: '编码不能为空', trigger: 'blur' }]
}
const dialogVisible = ref(false)
const title = ref('新增菜单')
const open = (text: string, data?: anyObj) => {
    title.value = text
    dialogVisible.value = true
    if (data) {
        for (let key in form) {
            form[key] = data[key]
        }
    } else {
        for (let key in form) {
            form[key] = ''
        }
        form.sort = 100
        form.pid = 0
        form.type = 0
    }
}
const submit = async () => {
     formRef.value.validate(async (valid: boolean) => {
        if (valid) {
             if (form.id) {
                await dicUpdate(form)
            } else {
                await dicAdd(form)
            }
            ElMessage.success('保存成功')
            tableStore.index()
            dialogVisible.value = false
        }
    })
   
}

const handleInput = (val: string) => {
    form.name = val.replace(/\s+/g, '')
}

defineExpose({ open })
</script>
